﻿namespace ChartHangsWithEmfSvg
{
    using System;
    using System.Collections.Generic;
    using System.Drawing;
    using System.Drawing.Imaging;
    using System.IO;
    using System.Linq;
    using System.Windows;
    using Arction.WPF.LightningChartUltimate;
    using Size = System.Drawing.Size;

    class Program
    {
        [STAThread]
        static void Main(string[] args)
        {
            UserControl1 userControl1 = new UserControl1();
            
            userControl1.ChartControl.ViewXY.PointLineSeries.Add(userControl1.Curve1);
            userControl1.Curve1.AddPoints(CreatePoints(), true);
            userControl1.ChartControl.ViewXY.LegendBox.Visible = false;
            userControl1.ChartControl.ActiveView = ActiveView.ViewXY;
            userControl1.ChartControl.ViewXY.YAxes[0].SetRange(0.0, 11.0);
            userControl1.ChartControl.ViewXY.XAxes[0].SetRange(0.0, 50.0);
            Window window = new Window() 
            {
                Width = 707,
                Height = 500,
                WindowStyle = WindowStyle.None,
                ShowInTaskbar = false,
                ShowActivated = false
            };
            //userControl1.Loaded += (sender, eventArgs) => window.Close();

            window.Content = userControl1;
            window.Show();


            string emfPicture = "C:\\temp\\EmfPicture.emf";
            if (File.Exists(emfPicture))
            {
                File.Delete(emfPicture);
            }
            FileStream fileStream = new FileStream(emfPicture, FileMode.CreateNew, FileAccess.ReadWrite, FileShare.None);

            userControl1.ChartControl.SaveToStream(fileStream, TargetImageFormat.Emf, new BitmapAntialiasOptions(), 707, 500);//3507, 2480);
            fileStream.Close();
            fileStream.Dispose();

            string pngPicture = @"C:\\Temp\PngPicture.png";
            if (File.Exists(pngPicture))
            {
                File.Delete(pngPicture);
            }
            var size = new Size(3507, 2480);
            using (Metafile source = new Metafile(emfPicture))
            using (Bitmap target = new Bitmap(size.Width, size.Height))
            using (Graphics g = Graphics.FromImage(target))
            {
                g.DrawImage(source, 0, 0, size.Width, size.Height);
                target.Save(pngPicture, ImageFormat.Png);
            }
        }

        static SeriesPoint[] CreatePoints()
        {
            const int numbersOfPoints = 5000;
            List<SeriesPoint> points = new List<SeriesPoint>(numbersOfPoints);
            double xValue = 0;
            double oldYValue = 0;
            double addToYValue = 0.01;
            int changeValue = 0;
            for (int index = 0; index < numbersOfPoints; index++, xValue += 0.01)
            {
                oldYValue = oldYValue + addToYValue;
                points.Add(new SeriesPoint(xValue, oldYValue));
                int i = index / 100;
                if (i != changeValue)
                {
                    changeValue = i;
                    addToYValue = addToYValue * -1;
                }
            }

            return AddSomeMorePoints(points);
        }

        private static SeriesPoint[] AddSomeMorePoints(List<SeriesPoint> list)
        {
            List<SeriesPoint> newList = new List<SeriesPoint>(list);
            Stack<SeriesPoint> temp = new Stack<SeriesPoint>();
            foreach (SeriesPoint point in list)
            {
                temp.Push(point);
            }

            List<SeriesPoint> changedOrder = temp.ToList();
            List<SeriesPoint> listToAdd = changedOrder;
            double deltaX = 0.001;
            double deltaY = 1;
            for (int index = 0; index < 10; index++, deltaY++, deltaX += 0.001)
            {
                foreach (SeriesPoint point in listToAdd)
                {
                    newList.Add(new SeriesPoint(point.X + deltaX, point.Y + deltaY));
                }

                listToAdd = listToAdd == changedOrder ? list : changedOrder;
            }

            //using (StreamWriter file = new StreamWriter(@"C:\Temp\point.csv"))
            //{
            //    foreach (SeriesPoint item in newList)
            //    {
            //        file.WriteLine(item.X + "," + item.Y);
            //    }
            //}

            return newList.ToArray();
        }
    }
}
